package com.steerinfo.meterwork.meterworkstockonline.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.constants.DbConstants;
import com.steerinfo.meterwork.dto.StorageCollectModel;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkstockonline.model.MeterWorkStockOnline;
import com.steerinfo.meterwork.meterworkstockonline.service.IMeterWorkStockOnlineService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkStockOnline RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-11-18 04:16
 * 类描述
 * 修订历史：
 * 日期：2020-11-18
 * 作者：generator
 * 参考：
 * 描述：MeterWorkStockOnline RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterworkstockonlines")
public class MeterWorkStockOnlineController extends BaseRESTfulController {

    @Autowired
    IMeterWorkStockOnlineService meterWorkStockOnlineService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkstockonline:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkStockOnline> list = meterWorkStockOnlineService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkstockonline:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkStockOnline> list = meterWorkStockOnlineService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkStockOnline对象创建")
    @ApiImplicitParam(name = "meterWorkStockOnline", value = "详细实体meterWorkStockOnline", required = true, dataType = "MeterWorkStockOnline")
    //@RequiresPermissions("meterworkstockonline:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkStockOnline model) {
        try {
            MeterWorkStockOnline meterWorkStockOnline = meterWorkStockOnlineService.add(model);
            return success(meterWorkStockOnline);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkstockonline:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterWorkStockOnline meterWorkStockOnline = meterWorkStockOnlineService.getById(id);
            return success(meterWorkStockOnline);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterWorkStockOnline信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterWorkStockOnline", value = "详细实体meterWorkStockOnline", required = true, dataType = "MeterWorkStockOnline")
    })
    //@RequiresPermissions("meterworkstockonline:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkStockOnline model) {
        try {
            model.setId(id);
            MeterWorkStockOnline meterWorkStockOnline = meterWorkStockOnlineService.modify(model);
            return success(meterWorkStockOnline);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkstockonline:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterWorkStockOnlineService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "C#获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkstockonline:view")
    @GetMapping(value = "/doQueryWf")
    public RESTfulResult doQueryWf(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkStockOnline> list = meterWorkStockOnlineService.doQueryWf(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "C#根据传入的实体进行修改")
    @PostMapping(value = "/doSaveWf")
    public RESTfulResult doSaveWf(@RequestBody MeterWorkStockOnline model) {
        try {
            String no = meterWorkStockOnlineService.doSaveWf(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "C#获取缓存数据")
    @PostMapping(value = "/doQueryStaticDbWf")
    public RESTfulResult doQueryStaticDbWf() {
        try {
            List<StorageCollectModel> list = DbConstants.StorageList;
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }


//    @PostMapping(value = "/automaticLock")
//    public RESTfulResult automaticLock(@RequestBody MeterWorkStockOnline model){
//        PageList<MeterWorkStockOnline> list= meterWorkStockOnlineService.automaticLock(model);
//        if (list == null ){
//            return failed(null,"不存在有任务的计量点");
//        }
//        return success(list);
//    }
//
//    @ApiOperation(value="解锁", notes="根据MeterWorkStockOnline对象")
//    @ApiImplicitParam(name = "meterWorkStockOnline", value = "详细实体meterWorkStockOnline", required = true, dataType = "MeterWorkStockOnline")
//    //@RequiresPermissions("meterworkstockonline:create")
//    @PostMapping(value = "/unlockWf")
//    public RESTfulResult unlockWf(@RequestBody MeterWorkStockOnline model){
//        PageList<MeterWorkStockOnline> list = meterWorkStockOnlineService.unlockWf(model);
//        return success(list);
//    }
//
//    @ApiOperation(value="锁定", notes="根据MeterWorkStockOnline对象")
//    @ApiImplicitParam(name = "meterWorkStockOnline", value = "详细实体meterWorkStockOnline", required = true, dataType = "MeterWorkStockOnline")
//    //@RequiresPermissions("meterworkstockonline:create")
//    @PostMapping(value = "/lockWf")
//    public RESTfulResult lockWf(@RequestBody MeterWorkStockOnline model){
//        PageList<MeterWorkStockOnline> list = meterWorkStockOnlineService.lockWf(model);
//        if (list == null ){
//            return failed(null,"该IP已有接管");
//        }
//        return success(list);
//    }

}
